"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _1 = require(".");
var utils_1 = require("../epoxy/typedefs-mergers/utils");
function extractFieldResolversFromObjectType(objectType, options) {
    var fieldResolvers = {};
    var fieldMap = objectType.getFields();
    var selectedFieldNames;
    if (options && options.selectedTypeDefs) {
        var definitionNodes = _1.getDefinitionNodesFromTypeDefs(options.selectedTypeDefs);
        var definitionNode = definitionNodes.find(function (definitionNode) {
            if (utils_1.isGraphQLType(definitionNode) || utils_1.isGraphQLTypeExtension(definitionNode)) {
                return definitionNode.name.value === objectType.name;
            }
            else {
                return false;
            }
        });
        if (definitionNode) {
            selectedFieldNames = definitionNode.fields.map(function (field) { return field.name.value; });
        }
        else {
            return {};
        }
    }
    for (var fieldName in fieldMap) {
        if (selectedFieldNames && !selectedFieldNames.includes(fieldName)) {
            continue;
        }
        var fieldDefinition = fieldMap[fieldName];
        if ('subscribe' in fieldDefinition) {
            fieldResolvers[fieldName] = {
                subscribe: fieldDefinition.subscribe,
            };
        }
        else if ('resolve' in fieldDefinition) {
            fieldResolvers[fieldName] = fieldDefinition.resolve;
        }
    }
    return fieldResolvers;
}
exports.extractFieldResolversFromObjectType = extractFieldResolversFromObjectType;
//# sourceMappingURL=extract-field-resolvers-from-object-type.js.map